/*
*/
#include	"C2_Port.h"

sbit  C2CK = P3^6;                   //C2CK
sbit  C2D = P3^7;                    // C2D
sbit  RstN = P3^5;	//Rst_nΪߵƽȴ2ms,Ȼc2ݣԼ10msʱ
					//дc2_mcuĴȻmcu_clkʱӻ
/*
sbit  WR_N	= P2^0;
sbit  CD	= P2^1;
sbit  RD_N	= P2^2;
sbit  CS_N 	= P2^3;
sbit  BL_N  = P2^4;
*/

sbit	CS0	    = P1^0;
sbit	N_STR0	= P1^1;
sbit	N_REC0  = P1^2;
sbit	CS1		= P1^3;
sbit	N_STR1	= P1^4;
sbit	N_REC1  = P1^5;
sbit	N_WE	= P1^6;

unsigned int wFlashAddr;
unsigned char byNumBytes;
unsigned char xdata *C2_Ptr;
unsigned char xdata pC2_Buf[256];

/***********************
//
//
//12T(22.1148MHz)
//2.04us
***********************/
void Dly2ms(void)
{
	unsigned int j;

	for (j=0; j<600; j++)
		_nop_();

}
//22.1148MHz@12TһָԼ0.54us
#define		NOP_20US	_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();\
						_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();\
						_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();\
						_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_();_nop_()
/***********************
//
//
//
***********************/
void C2_Reset()
{
	C2CK = LOW;                         // Put target device in reset state by pulling
	NOP_20US;                       	// C2CK low for >20us
	C2CK = HIGH;                        // Release target device from reset
}
/***********************
//
//
//ַĴ
***********************/
unsigned char C2_ReadAR()
{
	unsigned char i;                    // Bit counter
	unsigned char addr;                 // Address register read content
	
	// START field
	StrobeC2CK;                         // Strobe C2CK with C2D driver disabled
	// INS field (10b, LSB first)
	C2D = LOW;                       
	C2D_DriverOn;                       // Enable C2D driver (output)
	StrobeC2CK;
	C2D = HIGH;
	StrobeC2CK;
	C2D_DriverOff;                      // Disable C2D driver (input)
	// ADDRESS field
	addr = 0;
	for (i=0; i<8; i++)                   // Shift in 8 bit ADDRESS field
	{                                   // LSB-first
		addr >>= 1;                   
		StrobeC2CK;     
		if (C2D)
			addr |= 0x80;
	}              
	// STOP field
	StrobeC2CK;                         // Strobe C2CK with C2D driver disabled
	return addr;                        // Return Address register read value
}
/***********************
//
//
//дַĴ
***********************/
void C2_WriteAR(unsigned char addr)
{
	unsigned char i;                    // Bit counter

	// START field
	StrobeC2CK;                         // Strobe C2CK with C2D driver disabled
	// INS field (11b, LSB first)
	C2D = HIGH;             
	C2D_DriverOn;                       // Enable C2D driver (output)
	StrobeC2CK; 
	C2D = HIGH;
	StrobeC2CK;
	// ADDRESS field
	for(i=0; i<8; i++)                    // Shift out 8-bit ADDRESS field
	{
		C2D = (addr & 0x01);
		StrobeC2CK;
		addr >>= 1;
	}
	// STOP field
	C2D_DriverOff;                      // Disable C2D driver
	StrobeC2CK;                         // Strobe C2CK with C2D driver disabled
	return;
}
/***********************
//
//
//ݼĴ
***********************/
unsigned char C2_ReadDR()
{
	unsigned char i;                    // Bit counter
	unsigned char dat;                  // Data register read content
	
	_nop_();
	// START field
	StrobeC2CK;                         // Strobe C2CK with C2D driver disabled
	// INS field (00b, LSB first)
	C2D = LOW;
	C2D_DriverOn;                       // Enable C2D driver (output)
	StrobeC2CK;
	C2D = LOW;
	StrobeC2CK;
	// LENGTH field (00b -> 1 byte)
	C2D = LOW;
	StrobeC2CK;
	C2D = LOW;
	StrobeC2CK;
	// WAIT field
	C2D_DriverOff;                      // Disable C2D driver for input
	do
	{
		StrobeC2CK;
	}
	while (!C2D);                       // Strobe C2CK until target transmits a '1'
	// DATA field
	dat = 0;
	for (i=0; i<8; i++)                   // Shift in 8-bit DATA field
	{                                   // LSB-first
		dat >>= 1;
		StrobeC2CK;
		if (C2D)
			dat  |= 0x80;
	}
	// STOP field
	StrobeC2CK;                         // Strobe C2CK with C2D driver disabled

	while(1)//ÿִData Read󣬶ѯRd_AckRd_ ReqѾΪ0
	{
		i = C2_ReadAR();
		if ( i & ( (0x01 << RD_ACK) | (0x01 << RD_REQ) ) )
			_nop_();
		else
			break;
	}
	return dat;
}
/***********************
//
//
//дݼĴ
***********************/
void C2_WriteDR(unsigned char dat)
{
	unsigned char i;                    // Bit counter

	_nop_();
	// START field
	StrobeC2CK;                         // Strobe C2CK with C2D driver disabled
	// INS field (01b, LSB first)
	C2D = HIGH;
	C2D_DriverOn;                       // Enable C2D driver
	StrobeC2CK;
	C2D = LOW;
	StrobeC2CK;
	// LENGTH field (00b -> 1 byte)
	C2D = LOW;
	StrobeC2CK;
	C2D = LOW;
	StrobeC2CK;
	// DATA field
	for (i=0; i<8; i++)                   // Shift out 8-bit DATA field
	{                                   // LSB-first
		C2D = (dat & 0x01);
		StrobeC2CK;
		dat >>= 1;
	}
	// WAIT field
	C2D_DriverOff;                      // Disable C2D driver for input
	do
	{
		StrobeC2CK;                      // Strobe C2CK until target transmits a '1'
	}
	while (!C2D);
	// STOP field
	StrobeC2CK;                         // Strobe C2CK with C2D driver disabled

	while(1)//ÿִData Write󣬶ѯWr_AckWr_ ReqѾΪ0
	{
		i = C2_ReadAR();
		if ( i & ( (0x01 << WR_ACK) | (0x01 << WR_REQ) ) )
			_nop_();
		else
			break;
	}

	return;
}
/***********************
//
//
//
***********************/
//22.1148MHz@12TһָԼ0.54us
#define		NOP_2US	_nop_();_nop_();_nop_();_nop_()
void C2_Init()
{
	C2_Reset();                         // ReDly3ustarget device
	NOP_2US;			                // Delay for at least 2us
	C2_WriteAR(FPCTL);                  // Target the C2 FLASH Programming
										// Control register (FPCTL:0x02) for C2 Data 
										// register accesses 
	C2_WriteDR(0x02);                   // Write the first key code to enable 
										// C2 FLASH programming
	C2_WriteDR(0x01);                   // Write the second key code to enable 
										// C2 FLASH programming
                    					// Delay for at least 20ms to ensure the
	Dly2ms();							// target is ready for C2 FLASH programming
}
/***********************
//
//
//
***********************/
unsigned char C2_GetDevID()
{
	C2_WriteAR(DEVICEID);         		// Select DeviceID regsiter for C2 Data 
										// register accesses
	return C2_ReadDR();                 // Read and return the DeviceID register
}
/***********************
//wFlashAddr ʼַ
//byNumBytes ֽ==0ʱʾ256ֽڣ
//C2_Ptr	 ָ
//ROM
***********************/
char C2_BlockRead()
{
	unsigned int wNumBytesTmp;
	unsigned int i;                    	// Counter
	unsigned char status = 0;			// FPI status information holder
	
	C2_WriteAR(FPDAT);                  // Select the FLASH Programming Data register 
										// for C2 Data register accesses
	C2_WriteDR(BLOCK_READ);             // Send FLASH block read command
	Poll_InBusy;                        // Wait for input acknowledge
										// Check status before starting FLASH access sequence
	Poll_OutReady;                      // Wait for status information
	status = C2_ReadDR();               // Read FLASH programming interface status
	if (status != COMMAND_OK)
	{
		return 0;                       // Exit and indicate error
	}

	wFlashAddr |= (0x01 << 13);
	C2_WriteDR(wFlashAddr >> 8);        // Send address high byte to FPDAT
	Poll_InBusy;                        // Wait for input acknowledge
	C2_WriteDR(wFlashAddr & 0x00FF);    // Send address low byte to FPDAT
	Poll_InBusy;                        // Wait for input acknowledge
	C2_WriteDR(byNumBytes);              // Send block size
	Poll_InBusy;                        // Wait for input acknowledge
										// Check status before reading FLASH block
	Poll_OutReady;                      // Wait for status information
	status = C2_ReadDR();               // Read FLASH programming interface status
	if (status != COMMAND_OK)
	{
		return 0;                        // Exit and indicate error
	}	
	// Read FLASH block

	if (byNumBytes == 0)
	{
		wNumBytesTmp = 256;	
	}
	else
	{
		wNumBytesTmp = (unsigned int) byNumBytes;	
	}
	for (i=0; i<wNumBytesTmp; i++)
	{
		Poll_OutReady;                   // Wait for data ready indicator
		*C2_Ptr = C2_ReadDR();         // Read data from the FPDAT register
		C2_Ptr++;
	}
	return 1;                           // Exit and indicate success
}
/***********************
//wFlashAddr ʼַ
//byNumBytes ֽ==0ʱʾ256ֽڣ
//C2_Ptr	 ָ
//ROMд
***********************/
char C2_BlockWrite()
{
	unsigned int wNumBytesTmp;
	unsigned int i;                    	// Counter
	unsigned char status = 0;           // FPI status information holder

	C2_WriteAR(FPDAT);                  // Select the FLASH Programming Data register 
										// for C2 Data register accesses
	C2_WriteDR(BLOCK_WRITE);            // Send FLASH block write command
	Poll_InBusy;                        // Wait for input acknowledge
										// Check status before starting FLASH access sequence
	Poll_OutReady;                      // Wait for status information
	status = C2_ReadDR();               // Read FLASH programming interface status
	if (status != COMMAND_OK)
	{
		return 0;						// Exit and indicate error
	}

	wFlashAddr |= (0x01 << 13);
	C2_WriteDR(wFlashAddr >> 8);        // Send address high byte to FPDAT
	Poll_InBusy;                        // Wait for input acknowledge
	C2_WriteDR(wFlashAddr & 0x00FF);    // Send address low byte to FPDAT
	Poll_InBusy;                        // Wait for input acknowledge
	C2_WriteDR(byNumBytes);              // Send block size
	Poll_InBusy;                        // Wait for input acknolwedge
										// Check status before writing FLASH block
	Poll_OutReady;                      // Wait for status information
	status = C2_ReadDR();               // Read FLASH programming interface status
	if (status != COMMAND_OK)
	{
		return 0;                        // Exit and indicate error
	}
	// Write FLASH block

	if (byNumBytes == 0)
	{
		wNumBytesTmp = 256;	
	}
	else
	{
		wNumBytesTmp = (unsigned int) byNumBytes;
	}
	for (i=0; i<wNumBytesTmp; i++)
	{
		C2_WriteDR(*C2_Ptr);           // Write data to the FPDAT register
		C2_Ptr++;
		Poll_InBusy;                     // Wait for input acknowledge--طҪж2011 12 07
										//ѯWr_AckWr_ ReqѾΪ0
	}
	Poll_OutReady;                      // Wait for last FLASH write to complete
	return 1;                           // Exit and indicate success
}

/***********************
//wFlashAddr ʼַ
//byNumBytes ֽ==0ʱʾ256ֽڣ
//C2_Ptr	 ָ
//Ĵ
***********************/
char C2_RegRead()
{
	unsigned int wNumBytesTmp;
	unsigned int i;                    	// Counter
	unsigned char status = 0;			// FPI status information holder
	
	C2_WriteAR(FPDAT);                  // Select the FLASH Programming Data register 
										// for C2 Data register accesses
	C2_WriteDR(BLOCK_READ);             // Send FLASH block read command
	Poll_InBusy;                        // Wait for input acknowledge
										// Check status before starting FLASH access sequence
	Poll_OutReady;                      // Wait for status information
	status = C2_ReadDR();               // Read FLASH programming interface status
	if (status != COMMAND_OK)
	{
		return 0;                       // Exit and indicate error
	}
	wFlashAddr &= ~(0x01 << 13);
	C2_WriteDR(wFlashAddr >> 8);        // Send address high byte to FPDAT
	Poll_InBusy;                        // Wait for input acknowledge
	C2_WriteDR(wFlashAddr & 0x00FF);    // Send address low byte to FPDAT

	Poll_InBusy;                        // Wait for input acknowledge
	C2_WriteDR(byNumBytes);              // Send block size
	Poll_InBusy;                        // Wait for input acknowledge
										// Check status before reading FLASH block
	Poll_OutReady;                      // Wait for status information
	status = C2_ReadDR();               // Read FLASH programming interface status
	if (status != COMMAND_OK)
	{
		return 0;                        // Exit and indicate error
	}	
	// Read FLASH block

	if(byNumBytes == 0)
	{
		wNumBytesTmp = 256;	
	}
	else
	{
		wNumBytesTmp = (unsigned int) byNumBytes;	
	}
	//NumBytesTmp--;
	for (i=0; i<wNumBytesTmp; i++)
	{
		Poll_OutReady_01;                   // Wait for data ready indicator
		*C2_Ptr = C2_ReadDR();         	// Read data from the FPDAT register
		C2_Ptr++;									//ѯRd_AckRd_ ReqѾΪ0
	}
	return 1;                           // Exit and indicate success
}
/***********************
//wFlashAddr ʼַ
//byNumBytes ֽ==0ʱʾ256ֽڣ
//C2_Ptr	 ָ
//Ĵд
***********************/
char C2_RegWrite()
{
	unsigned int wNumBytesTmp;
	unsigned int i;                    	// Counter
	unsigned char status = 0;           // FPI status information holder

	C2_WriteAR(FPDAT);                  // Select the FLASH Programming Data register 
										// for C2 Data register accesses
	C2_WriteDR(BLOCK_WRITE);            // Send FLASH block write command
	Poll_InBusy;                        // Wait for input acknowledge
										// Check status before starting FLASH access sequence
	Poll_OutReady;                      // Wait for status information
	status = C2_ReadDR();               // Read FLASH programming interface status
	if (status != COMMAND_OK)
	{
		return 0;						// Exit and indicate error
	}
	wFlashAddr &= ~(0x01 << 13);
	C2_WriteDR(wFlashAddr >> 8);        // Send address high byte to FPDAT

	Poll_InBusy;                        // Wait for input acknowledge
	C2_WriteDR(wFlashAddr & 0x00FF);    // Send address low byte to FPDAT

	Poll_InBusy;                        // Wait for input acknowledge
	C2_WriteDR(byNumBytes);              	// Send block size
	Poll_InBusy;                        // Wait for input acknolwedge
										// Check status before writing FLASH block
	Poll_OutReady;                      // Wait for status information
	status = C2_ReadDR();               // Read FLASH programming interface status
	if (status != COMMAND_OK)
	{
		return 0;                        // Exit and indicate error
	}
	// Write FLASH block

	if (byNumBytes == 0)
	{
		wNumBytesTmp = 256;	
	}
	else
	{
		wNumBytesTmp = (unsigned int) byNumBytes;
	}
	//NumBytesTmp--;
	for (i=0; i<wNumBytesTmp; i++)
	{
		C2_WriteDR(*C2_Ptr);           // Write data to the FPDAT register
		C2_Ptr++;
		Poll_InBusy_01;                     // Wait for input acknowledge
	}
	Poll_OutReady;                      // Wait for last FLASH write to complete
	return 1;                           // Exit and indicate success
}
/////////////////////////////////////////// VFD test start
unsigned char code dis1[]={"Vacuum fluorescent Graphic Display Module "} ;

/*
unsigned char sendCOM(unsigned char dat)
{
	CD	 = 1;
	CS_N = 0;
	WR_N = 0;
	RD_N = 1;
	_nop_();_nop_();_nop_();_nop_();
	P1   = dat;
	_nop_();_nop_();_nop_();_nop_();
	WR_N = 1;
	_nop_();_nop_();_nop_();_nop_();
	CS_N = 1;
	WR_N = 1;
	RD_N = 1;
	CD	 = 1;

}

unsigned char senddata(unsigned char dat)
{
	CD	 = 0;
	CS_N = 0;
	WR_N = 0;
	RD_N = 1;
	_nop_();_nop_();_nop_();_nop_();
	P1   = dat;
	_nop_();_nop_();_nop_();_nop_();
	WR_N = 1;
	_nop_();_nop_();_nop_();_nop_();
	CS_N = 1;
	WR_N = 1;
	RD_N = 1;
	CD	 = 1;
}

unsigned char readdata()
{
	unsigned char tmp;
	CS_N = 0;
	WR_N = 1;
	RD_N = 0;
	CD	 = 0;
	_nop_();_nop_();_nop_();_nop_();
	tmp   = P1;
	_nop_();_nop_();_nop_();_nop_();
	return tmp;
}	*/

void display()
{
  unsigned char m;
   

}								 
/////////////////////////////////ttt
//////////nvram
void ReadRam_BACKUP(unsigned char address,unsigned char dat)
{
	unsigned int i   = 0;
	unsigned int Temp = 0 ;


	CS1  = 1;
	N_REC1 = 1;
	N_WE = 1;
	N_STR1 = 1;

	for(i=0;i<256;i++)
	{	
		P2 = 0xFF; 
		P0 = i;
		CS1 = 0;
		NOP_20US;
		Temp = P2;
		pC2_Buf[i] = Temp;
		CS1 = 1;
		UART_OutputChar(Temp);	
		TI = 1;
		Dly2ms();
	}		
}
void RamRecall_BACKUP(void)
{

	CS1  = 1;
	N_WE = 1;
	N_STR1 = 1;
	N_REC1 = 0;
	Dly2ms();
	N_REC1 = 1;		
}

void ReadRam(unsigned char address,unsigned char dat)
{
	unsigned int i   = 0;
	unsigned int Temp = 0 ;


	CS0  = 1;
	N_REC0 = 1;
	N_WE = 1;
	N_STR0 = 1;

	for(i=0;i<256;i++)
	{	
		P2 = 0xFF; 
		P0 = i;
		CS0 = 0;
		NOP_20US;
		Temp = P2;
		CS0 = 1;
		UART_OutputChar(Temp);	
		TI = 1;
		Dly2ms();
	}		
}

void WriteRam(unsigned char address,unsigned char dat)
{
	unsigned int i   = 0;
	unsigned int Temp = 0;

	CS0  = 1;
	N_REC0 = 1;
	N_WE = 1;
	N_STR0 = 1;

	for(i=0;i<256;i++)
	{	 
		P0 = i;
		CS0 = 0;
		NOP_20US;
		N_WE = 0;
		NOP_20US;
		P2 = pC2_Buf[i];
		CS0 = 1;
		N_WE =1;	
	}		
}

void RamRecall(void)
{

	CS0  = 1;
	N_WE = 1;
	N_STR0 = 1;
	N_REC0 = 0;
	Dly2ms();
	N_REC0 = 1;		
}

void RamStore(void)
{

	CS0  = 1;
	N_WE = 1;
	N_REC0 = 1;
	N_STR0 = 0;
	Dly2ms();
	Dly2ms();
	Dly2ms();
	Dly2ms();
	Dly2ms();  
	N_STR0 = 1;		
}
/////////////NVRAM END

void main(void)
{
	unsigned char tmp;
	unsigned int i;

	EA = 0;
	UART_Initail();
	//C2_Init();
	//C2_GetDevID();
	EA = 1;
/*
	sendCOM(0x01);
	sendCOM(0x04);
	sendCOM(0x10);
	sendCOM(0x0a);
	senddata(0x00);
 	sendCOM(0x0b);
	senddata(0x00);
	sendCOM(0x10);
	sendCOM(0x0c);
	senddata(0x00);
 	sendCOM(0x0d);
	senddata(0x08);	

	sendCOM(0x0e);
	senddata(0x00);
 	sendCOM(0x0f);
	senddata(0x00);
	sendCOM(0x08);	   
	for(i=0;i<2048;i++)
	{
		senddata(0x55);	
		Dly2ms();
	}

	sendCOM(0x0e);
	senddata(0x00);
 	sendCOM(0x0f);
	senddata(0x00);	
	sendCOM(0x08);
	for(i=0;i<2048;i++)
	{
		senddata(0xaa);	
		Dly2ms();
	}

	sendCOM(0x0e);
	senddata(0x00);
 	sendCOM(0x0f);
	senddata(0x00);
	sendCOM(0x08);	
	for(i=0;i<2048;i++)
	{
		senddata(0xff);	
		Dly2ms();
	}
	sendCOM(0x08);
	for(i=0;i<43;i++)
	{
		senddata(dis1[i]);	
		Dly2ms();
	}

	for(i=0;i<2005;i++)
	{
		senddata(0xec);	
		Dly2ms();
	}
	sendCOM(0x12);	
	sendCOM(0x03);		//both #1 and #2 are ON;   
	UART_OutputChar(0xfa);
	TI = 1;	*/
		
///////////////////////VFD test end

/////////////NVRAM
	RamRecall_BACKUP();
	ReadRam_BACKUP();
	UART_OutputChar(0x01);	
	WriteRam();
	ReadRam();
	UART_OutputChar(0x02);	
	RamStore();
	RamRecall();
	ReadRam();
	UART_OutputChar(0x03); 
	TI = 1;	 
/////////////NVRAM

	while(1)
	{		
		display();
	}
	///////////////////////





	C2_Ptr = pC2_Buf;
//	C2_BlockRead();
//	C2_BlockWrite();
//	C2_RegRead();
//	C2_RegWrite();
	UART_OutputChar(0xfa);
	TI = 1;
	RstN = 0;
	Dly2ms();
	Dly2ms();
	Dly2ms();
	while(1)
	{
		RstN = 1;
		Dly2ms();// 2ms
		C2_WriteAR(C2CTRL);
		C2_WriteDR( (0x01 << C2_MCU) );//C2ӹMCUC2״̬
	
		//tmp = C2_GetDevID();
		UART_OutputChar(tmp);
		TI = 1;
		while(1)
		{
			tmp = 0;
			UART_GetChar(&tmp);
			if (0xaa == tmp)
			{
				UART_OutputChar(0xaa);
				TI = 1;
				break;	
			}
		}

	}
	return;
}




// end of file